# Title

This is the title of the enhancement. Keep it simple and descriptive.

The file name should be lowercased and spaces/punctuation should be replaced with `-`.

## Summary

The Summary section is incredibly important for producing high-quality user-focused documentation such as release notes or a development roadmap.

A good summary is probably at least a paragraph in length.

### Related Issues

The URL For the related enhancement issues in the Longhorn repository.

## Motivation

### Goals

List the specific goals of the enhancement. How will we know that this has succeeded?

### Non-goals [optional]

What is out of scope for this enhancement? Listing non-goals helps to focus discussion and make progress.

## Proposal

This is where we get down to the nitty-gritty of what the proposal actually is.

### User Stories
Detail the things that people will be able to do if this enhancement is implemented. A good practice is including a comparison of what the user cannot do before the enhancement is implemented, why the user would want an enhancement, and what the user needs to do after, to make it clear why the enhancement is beneficial to the user.

The experience details should be in the `User Experience In Detail` later.

#### Story 1
#### Story 2

### User Experience In Detail

Detail what the user needs to do to use this enhancement. Include as much detail as possible so that people can understand the "how" of the system. The goal here is to make this feel real for users without getting bogged down.

### API changes

## Design

### Implementation Overview

Overview of how the enhancement will be implemented.

### Test plan

Integration test plan.

For engine enhancement, also requires engine integration test plan.

### Upgrade strategy

Anything that requires if the user wants to upgrade to this enhancement.

## Note [optional]

Additional notes.
